#include "header.h"
using namespace STDP;

void Sistema::cargarPerfiles()
{
	StdPijo& stdp = StdPijo::p();
	stdp.init();

	nP=0;

	ifstream file;
	string lectura="";

	file.open("perfiles.txt",ios::in);
	if (file.is_open())
	{
		getline(file,lectura);
		if(!file.eof())
		{
			for(int i=nP;i<kPerf && !lectura.empty();i++)
			{
				Perfiles[i].setNombre(lectura);
				getline(file,lectura);
				Perfiles[i].setFacil(atoi(lectura.c_str()));
				getline(file,lectura);
				Perfiles[i].setNormal(atoi(lectura.c_str()));
				getline(file,lectura);
				Perfiles[i].setDificil(atoi(lectura.c_str()));
				getline(file,lectura);
				Perfiles[i].setMuydificil(atoi(lectura.c_str()));
				getline(file,lectura);
				Perfiles[i].setDesbNormal((bool)atoi(lectura.c_str()));
				getline(file,lectura);
				Perfiles[i].setDesbDificil((bool)atoi(lectura.c_str()));
				getline(file,lectura);
				Perfiles[i].setDesbMDificil((bool)atoi(lectura.c_str()));

				nP++;

				getline(file,lectura);
			}
		}
		file.close();
	}
	else
	{
		stdp.setCursor(19,10); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                          ");
		stdp.setCursor(19,11); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("             ERROR EN MATRIX              ");
		stdp.setCursor(19,12); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                          ");
		stdp.setCursor(19,13); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("   Los perfiles no se han podido cargar   ");
		stdp.setCursor(19,14); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                          ");
	}
}

void Sistema::guardarPerfiles()
{
	StdPijo& stdp = StdPijo::p();
	stdp.init();

	ofstream file;

	file.open("perfiles.txt",ios::out);
	if (file.is_open())
	{
		for(int i=0;i<nP;i++)
		{
			file << Perfiles[i].getNombre() << endl;
			file << Perfiles[i].getFacil() << endl;
			file << Perfiles[i].getNormal() << endl;
			file << Perfiles[i].getDificil() << endl;
			file << Perfiles[i].getMuydificil() << endl;
			file << Perfiles[i].getDesbNormal() << endl;
			file << Perfiles[i].getDesbDificil() << endl;
			file << Perfiles[i].getDesbMDificil() << endl;
		}
		file << endl;
		file.close();
	}
	else
	{
		stdp.setCursor(18,10); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                           ");
		stdp.setCursor(18,11); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("             ERROR EN MATRIX               ");
		stdp.setCursor(18,12); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                           ");
		stdp.setCursor(18,13); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("   Los perfiles no se han podido guardar   ");
		stdp.setCursor(18,14); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                           ");
	}
}

void Sistema::borrarPerfil(int num)
{
	for(int i=num;i<nP;i++)
	{
		Perfiles[i]=Perfiles[i+1];
	}
	nP--;
}

void Sistema::cargarRanking(int dif)
{
	StdPijo& stdp = StdPijo::p();
	stdp.init();

	string nombre="";

	switch(dif)
	{
	case 1: nombre = "facil.txt"; break;
	case 2: nombre = "normal.txt"; break;
	case 3: nombre = "dificil.txt"; break;
	case 4: nombre = "muydificil.txt"; break;
	}

	nR=0;

	ifstream file;
	string lectura="";

	file.open(nombre.c_str(),ios::in);
	if (file.is_open())
	{
		getline(file,lectura);
		if(!file.eof())
		{
			for(int i=nR;i<kRank && !lectura.empty();i++)
			{
				Ranking[i].setNombre(lectura);
				getline(file,lectura);
				Ranking[i].setPuntuacion(atoi(lectura.c_str()));
				nR++;

				getline(file,lectura);
			}
		}
		file.close();
	}
	else
	{
		stdp.setCursor(19,10); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                          ");
		stdp.setCursor(19,11); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("             ERROR EN MATRIX              ");
		stdp.setCursor(19,12); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                          ");
		stdp.setCursor(19,13); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("    El ranking no se ha podido cargar     ");
		stdp.setCursor(19,14); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                          ");
	}
}

void Sistema::insertarRank(Jugador nrank)
{
	bool cond = 0;

	for(int i=nR; i>=0; i--)
	{
		if(!cond)
		{
			if(nR==0 || i==0)
			{
				Ranking[0].setNombre(nrank.getNombre());
				Ranking[0].setPuntuacion(nrank.getPuntuacion());
				nR++;
				cond=true;
			}
			else if(nrank.getPuntuacion()<=Ranking[i-1].getPuntuacion())
			{
				Ranking[i].setNombre(nrank.getNombre());
				Ranking[i].setPuntuacion(nrank.getPuntuacion());
				nR++;
				cond=true;
			}
			else
			{
				Ranking[i]=Ranking[i-1];
}	}	}	}

int Sistema::sacaRank(Jugador player)
{
	for(int i=0;i<nR;i++)
	{ if(player.getNombre()==Ranking[i].getNombre()) { return (i+1); } }
	return 0;
}

void Sistema::guardarRanking(int dif)
{
	StdPijo& stdp = StdPijo::p();
	stdp.init();

	string nombre="";

	switch(dif)
	{
	case 1: nombre = "facil.txt"; break;
	case 2: nombre = "normal.txt"; break;
	case 3: nombre = "dificil.txt"; break;
	case 4: nombre = "muydificil.txt"; break;
	}

	ofstream file;

	file.open(nombre.c_str(),ios::out);
	if (file.is_open())
	{
		file.clear();
		for(int i=0;i<nR;i++)
		{
			file << Ranking[i].getNombre() << endl;
			file << Ranking[i].getPuntuacion() << endl;
		}
		file.close();
	}
	else
		{
			stdp.setCursor(19,10); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                          ");
			stdp.setCursor(19,11); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("             ERROR EN MATRIX              ");
			stdp.setCursor(19,12); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                          ");
			stdp.setCursor(19,13); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("    El ranking no se ha podido guardar    ");
			stdp.setCursor(19,14); stdp.setColor(ABOLD, CBLACK, CGREEN); stdp.writeStr("                                          ");
		}
}

